#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include "red.xpm"
#include "green.xpm"

/* globals */
static EggTrayIcon *docklet = NULL;
static GtkWidget *image = NULL;
GdkPixbuf *icons[2] = { NULL, NULL };
extern GtkWidget *window;
extern int is_alert;

/* protos */
void docklet_clicked_cb(GtkWidget *button, GdkEventButton *event, void *data);
void docklet_destroy();
void docklet_create();

void set_icon(void)
{
	if (icons[is_alert])
    		gtk_image_set_from_pixbuf(GTK_IMAGE(image), icons[is_alert]);
}

void docklet_clicked_cb(GtkWidget *button, GdkEventButton *event, void *data)
{
	if (event->type != GDK_BUTTON_PRESS)
		return;
	docklet_destroy();
	gtk_widget_show(window);
}

void docklet_destroy()
{
	int i;
	
	gtk_widget_destroy(GTK_WIDGET(docklet));

	g_object_unref(G_OBJECT(docklet));
	docklet = NULL;

	for (i = 0; i < 2; i++) {
		if (icons[i])
			g_object_unref(G_OBJECT(icons[i]));
		icons[i] = NULL;
	}
}

void docklet_create()
{
	GtkWidget *box;

	if (docklet) {
		/* if this is being called when a tray icon exists, it's because
		   something messed up. try destroying it before we proceed,
		   although docklet_refcount may be all hosed. hopefully won't happen. */
		docklet_destroy();
	}

	docklet = egg_tray_icon_new("NAGV");
	box = gtk_event_box_new();
	image = gtk_image_new();
	
	g_signal_connect(G_OBJECT(box), "button-press-event", G_CALLBACK(docklet_clicked_cb), NULL);

	gtk_container_add(GTK_CONTAINER(box), image);
	gtk_container_add(GTK_CONTAINER(docklet), box);
	gtk_widget_show_all(GTK_WIDGET(docklet));

	/* ref the docklet before we bandy it about the place */
	g_object_ref(G_OBJECT(docklet));
	if (!icons[0])
        	icons[0] = gdk_pixbuf_new_from_xpm_data((const char **)green_xpm);
	if (!icons[1])
		icons[1] = gdk_pixbuf_new_from_xpm_data((const char **)red_xpm);
	set_icon();
}
